package primi;
public class Crivello extends AbstractPrimi{
    boolean[] primi;

    public Crivello(long n){
    	super(n);
    	this.primi = new boolean[(int) n];
    }
    
    public int go(){
		primi[0] = primi[1] = false;
		for (int i = 2; i < n; i++)
			primi[i] = true;
		int i = 1;
		while (i * i < n) {
			while (!primi[++i]) {}
			for (int k = i * i; k < n; k += i)
				primi[k] = false;
		}
		int p = 0;
		for (int j = 2; j < n; j++)
			if (primi[j])
				p++;
		return p;
	}
}