package primi;

import java.util.BitSet;

public class PrimeSet2 {
	private BitSet primeset;

	public PrimeSet2(long n) {
		this.primeset = new BitSet((int) (n / 2));
	}

	public void set(long fromIndex, long toIndex) {
		for (long i = fromIndex; i < toIndex; i++)
			this.set(i);
	}

	public long nextSetBit(long fromIndex) {
		long i = fromIndex;
		while (!this.get(i++)) {}
		return i - 1;
	}

	public int cardinality() {
		return primeset.cardinality() + 1;
	}

	public void set(long i) {
		if (i % 2 == 0) return;
		primeset.set((int) (i / 2));
	}

	public void clear(long i) {
		if (i % 2 == 0) return;
		primeset.clear((int) (i / 2));
	}

	public boolean get(long i) {
		if (i % 2 == 0) return false;
		return primeset.get((int) (i / 2));
	}
}
