package primi;
public class Primi3 extends AbstractPrimi{
    boolean[] primi;
    int p=0;

    public Primi3(long n){
    	super(n);
    	this.primi = new boolean[(int) n];
    }
    
    public int go(){
		primi[0] = primi[1] = false;
		primi[2] = true;
		for (int i = 3; i < n; i += 2) {
			primi[i] = true;
			for (int j = 3; j * j <= i; j += 2)
				if (primi[j] && i % j == 0) {
					primi[i] = false;
					break;
				}
		}
		for (int j = 2; j < n; j++)
			if (primi[j])
				p++;
		return p;
	}

}