package test;

import java.util.*;

public class Report {
	Set<String> xSet, ySet;

	Map<String, String> zxy;

	public Report() {
		this.xSet = new TreeSet<String>();
		this.ySet = new TreeSet<String>();
		this.zxy = new HashMap<String, String>();
	}

	public void put(String x, String y, String z) {
		xSet.add(x);
		ySet.add(y);
		String xy = "[" + x + "," + y + "]";
		zxy.put(xy, z);
	}

	public String[][] getReport() {
		int xn = xSet.size();
		int yn = ySet.size();
		int maxlen=0;
		String[][] res = new String[xn + 1][yn + 1];
		int k = 1;
		for (String x : xSet) {
			res[k][0] = x;
			maxlen=Math.max(maxlen, res[k][0].length());
			k++;
		}
		k = 1;
		for (String y : ySet) {
			res[0][k] = y;
			maxlen=Math.max(maxlen, res[0][k].length());
			k++;
		}
        res[0][0]="";
		for (int i = 1; i <= xn; i++)
			for (int j = 1; j <= yn; j++) {
				String s = zxy.get("[" + res[i][0] + "," + res[0][j] + "]");
				if (s == null)
					res[i][j] = "        -";
				else
					res[i][j] = s;
				maxlen=Math.max(maxlen, res[i][j].length());
			}
		for (int i = 0; i <= xn; i++)
			for (int j = 0; j <= yn; j++) 
		res[i][j]=(res[i][j] + "                                              ").substring(0, maxlen+1);					
		return res;
	}

}